<template>
  <div v-if="value" class="modal">
    <div class="modal-mask" @click="closeModal" />
    <div class="modal-window">
      <div class="modal-title">
        <span class="modal-title-text">{{ title }}</span>
        <span class="modal-close" @click="closeModal">
          <i class="material-icons">close</i>
        </span>
      </div>
      <div class="modal-content">
        <slot />
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    title: { type: String, required: true },
    value: { type: Boolean, default: false }
  },
  methods: {
    closeModal () {
      this.$emit('input', false)
    }
  }
}
</script>

<style lang="scss" scoped>
.modal {
  .modal-mask {
    position: absolute;
    top: 0;
    left: 0;

    width: 100%;
    height: 100%;

    background-color: #0009;
  }

  .modal-window {
    .modal-title {
      .modal-title-text {
        margin: auto;
      }

      .modal-close {
        .material-icons {
          margin: auto;
        }

        display: flex;

        vertical-align: middle;

        width: 1.5em;
        height: 1.5em;

        cursor: pointer;

        border-radius: 50%;
      }

      .modal-close:hover {
        background-color: #0003;
      }

      display: flex;

      padding: 0.5em;
      font-size: 1.5em;
      color: white;

      background-color: #2a88ad;
    }

    .modal-content {
      max-height: 40em;
      overflow: auto;
    }

    position: absolute;

    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);

    min-width: 20em;
    min-height: 10em;

    background-color: white;
    box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);
  }

  .modal-window::after {
    content: "";
  }

  position: fixed;
  top: 0;
  left: 0;

  width: 100%;
  height: 100%;
}
</style>
